Package org.zkoss.stateless.sul

## Interface IStep

- All Superinterfaces:
    `IAnyGroup<IStep>`, `IComponent<IStep>`, `IHtmlBasedComponent<IStep>`, `IXulElement<IStep>`

      public interface IStep
      extends IXulElement<IStep>, IAnyGroup<IStep>

  Immutable `Step` component

  A step is used for displaying user navigation, it should be placed inside a `IStepbar`.

  Author:
    katherine
  See Also:
    `Step`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static class` | `IStep.Builder` | Builds instances of type `IStep`.
    `static class` | `IStep.Updater` | Builds an updater of type `IStep` for `UiAgent.smartUpdate(Locator, SmartUpdater)`.

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static IStep` | `DEFAULT` | Constant for default attributes of this immutable component.

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.lang.String` | `getIconSclass()` | Returns the icon font
    `java.lang.String` | `getTitle()` | Returns the title.
    `default java.lang.String` | `getWidgetClass()` | Returns the client widget class.
    `default boolean` | `isComplete()` | Returns whether this step is complete.
    `default boolean` | `isError()` | Returns whether this step is in error.
    `static IStep` | `ofId​(java.lang.String id)` | Returns the instance with the given id.
    `static IStep` | `ofTitle​(java.lang.String title)` | Returns the instance with the given title.
    `IStep` | `withComplete​(boolean complete)` | Returns a copy of `this` immutable component with the specified `complete`.
    `IStep` | `withError​(boolean error)` | Returns a copy of `this` immutable component with the specified `error`.
    `IStep` | `withIconSclass​(java.lang.String iconSclass)` | Returns a copy of `this` immutable component with the specified `iconSclass`.
    `IStep` | `withTitle​(java.lang.String title)` | Returns a copy of `this` immutable component with the specified `title`.

    - ### Methods inherited from interface org.zkoss.stateless.sul.IComponent

      `getAction, getActions, getClientAttributes, getId, getMold, getWidgetListeners, getWidgetOverrides, isVisible, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withActions, withActions, withClientAttribute, withClientAttributes, withId, withMold, withVisible, withWidgetClass, withWidgetListener, withWidgetListeners, withWidgetOverride, withWidgetOverrides`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IHtmlBasedComponent

      `getClientAction, getDraggable, getDroppable, getHeight, getHflex, getLeft, getRenderdefer, getSclass, getStyle, getTabindex, getTooltiptext, getTop, getVflex, getWidth, getZclass, getZIndex, isFocus, withClientAction, withDraggable, withDroppable, withFocus, withHeight, withHflex, withLeft, withRenderdefer, withSclass, withStyle, withTabindex, withTabindex, withTooltiptext, withTop, withVflex, withWidth, withZclass, withZIndex`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IXulElement

      `getContext, getCtrlKeys, getPopup, getTooltip, withContext, withCtrlKeys, withPopup, withTooltip`

- - ### Field Detail

    - #### DEFAULT

          static final IStep DEFAULT

      Constant for default attributes of this immutable component.

  - ### Method Detail

    - #### getWidgetClass

          default java.lang.String getWidgetClass()

      Returns the client widget class.

      Default: `"zkmax.wgt.Step"`

      Specified by:
        `getWidgetClass` in interface `IComponent<IStep>`

    - #### getTitle

          @Nullable
          java.lang.String getTitle()

      Returns the title.

      Default: `null`.

    - #### withTitle

          IStep withTitle​(@Nullable
                          java.lang.String title)

      Returns a copy of `this` immutable component with the specified `title`.

      Sets the title of the step.

      Parameters:
        `title` - The title of the step.

        Default: `null`.

      Returns:
        A modified copy of the `this` object

    - #### getIconSclass

          @Nullable
          java.lang.String getIconSclass()

      Returns the icon font

      Default: `null`.

    - #### withIconSclass

          IStep withIconSclass​(@Nullable
                               java.lang.String iconSclass)

      Returns a copy of `this` immutable component with the specified `iconSclass`.

      Sets the icon font

      Parameters:
        `iconSclass` - The icon font

        Default: `null`.

      Returns:
        A modified copy of the `this` object

    - #### isComplete

          default boolean isComplete()

      Returns whether this step is complete.

      Default: `false`.

    - #### withComplete

          IStep withComplete​(boolean complete)

      Returns a copy of `this` immutable component with the specified `complete`.

      Sets whether this step is complete.

      Parameters:
        `complete` - Whether this step is complete.

        Default: `false`.

      Returns:
        A modified copy of the `this` object

    - #### isError

          default boolean isError()

      Returns whether this step is in error.

      Default: `false`.

    - #### withError

          IStep withError​(boolean error)

      Returns a copy of `this` immutable component with the specified `error`.

      Sets whether this step is in error.

      Parameters:
        `error` - Whether this step is in error.

        Default: `false`.

      Returns:
        A modified copy of the `this` object

    - #### ofTitle

          static IStep ofTitle​(java.lang.String title)

      Returns the instance with the given title.
      Parameters:
        `title` - The title of this component

    - #### ofId

          static IStep ofId​(java.lang.String id)

      Returns the instance with the given id.
      Parameters:
        `id` - The id to identify this component